<template>

<div class="
    flex
    flex-wrap
    justify-center
">
    <button
        v-bind:key="key"
        v-for="(value, key) in list"
        v-bind:class="{
            'border-gray-400 dark:border-cgray-400' : columns.includes(value),
            'border-gray-300 dark:border-cgray-600' : ! columns.includes(value),
            'font-black': project.reports.current.values.current === value
        }"
        v-on:click="refreshColumns(value)"
        class="
        px-3
        py-1
        rounded-full
        mb-1
        ml-1
        text-xs
        font-semibold
        border-2
        bg-gray-200
        hover:bg-gray-200
        dark:bg-cgray-800
        dark:hover:bg-cgray-700
    ">
        {{ $t(value) }}
    </button>
</div>

</template>

<script lang='ts'>

import { Component, Prop, Vue } from 'vue-property-decorator';
import { State } from 'vuex-class';

import { Project } from '@/ts/project';

@Component
export default class C extends Vue {
    @State('project')
    private project!: Project;

    @Prop()
    private columns!: string[];

    @Prop()
    private columnsHistory!: string[];

    private list: String[] = [];

    private mounted() {
        if (this.project.reports.current) {
            this.list = [...this.project.reports.current.values.list].sort(this.project.reports.current.sortValues);
        }
    }

    private refreshColumns(value: string): void {
        if (!this.columns.includes(value)) {
            const index = this.columns.indexOf(this.columnsHistory[2], 0);
            if (index > -1) {
                this.columns.splice(index, 1);
            }
            this.columns.push(value);

            this.columns.sort((this.project.reports.current as any).sortValues);

            this.columnsHistory.splice(2, 1);
            this.columnsHistory.splice(0, 0, value);
        }
    }
}

</script>
